/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2009 Alpha Project Co., Ltd.
 *
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́C̏𖞂ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: if_ed.c,v 1.4 2007/11/09 00:42:31 abe Exp abe $
 */

/*-
 * Copyright (c) 2008 Benno Rice.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/if.h>
#include <net/ethernet.h>
#include <net/if_arp.h>
#include <net/net.h>
#include <net/net_timer.h>
#include <net/net_count.h>
#include <net/net_buf.h>

#include "if_smcreg.h"
#include "if_smcvar.h"
#include "mii.h"

#define DELAY(x)	sil_dly_nse(1000*x)

/*
 *  lbg[NC^tF[XɈˑ\tgEFA 
 */
typedef struct t_smc_softc {
	UINT	smc_chip;			/* `bvԍ */
	UINT	smc_rev;			/* rWԍ */

	UW		smc_reg;			/* Rg[AhX */
	int		phy_addr;			/* PHYAhX */

	UINT	smc_mask;			/* ݃}XN */

	T_NET_BUF *output;			/* Mobt@ */
} T_SMC_SOFTC;

/*
 *  lbg[NC^tF[X̃\tgEFA
 */

/* lbg[NC^tF[XɈˑ\tgEFA */
static T_SMC_SOFTC smc_softc = {
	0,
	0,

	ED_BASE_ADDRESS,
	0,

	0,

	NULL,
};

/* lbg[NC^tF[XɈˑȂ\tgEFA */
T_IF_SOFTC if_softc = {
	{},						/* lbg[NC^tF[X̃AhX	*/
	0,						/* M^CAEg			*/
	&smc_softc,				/* fBoCXˑ̃\tgEFA	*/
	SEM_IF_ED_SBUF_READY,	/* MZ}tH			*/
	SEM_IF_ED_RBUF_READY,	/* MZ}tH			*/
};

/*
 *  ֐
 */
static int smcphy_probe(T_IF_SOFTC *ic);


/*----------------------------------------------------------------------------*/

/*
 *  WX^ANZX֐
 */
static __inline void
smc_select_bank(T_SMC_SOFTC *sc, UH bank)
{
	sil_wrh_mem((VP)(sc->smc_reg + BSR), bank & BSR_BANK_MASK);
}

static __inline void
smc_mmu_wait(T_SMC_SOFTC *sc)
{
	while (sil_reh_mem((VP)(sc->smc_reg + MMUCR)) & MMUCR_BUSY);
}

static __inline UB
smc_read_1(T_SMC_SOFTC *sc, UH offset)
{
	return (sil_reb_mem((VP)(sc->smc_reg + offset)));
}

static __inline void
smc_write_1(T_SMC_SOFTC *sc, UH offset, UB val)
{
	sil_wrb_mem((VP)(sc->smc_reg + offset), val);
}

static __inline UH
smc_read_2(T_SMC_SOFTC *sc, UH offset)
{
	return (sil_reh_mem((VP)(sc->smc_reg + offset)));
}

static __inline void
smc_write_2(T_SMC_SOFTC *sc, UH offset, UH val)
{
	sil_wrh_mem((VP)(sc->smc_reg + offset), val);
}

/*----------------------------------------------------------------------------*/
static void
smc_tx(T_IF_SOFTC *ic, T_NET_BUF *output)
{
	T_SMC_SOFTC	*sc = ic->sc;
	UINT		packet;
	UINT		len;
	UH			*data;
	int			i;

	/* oNؑ */
	smc_select_bank(sc, 2);

	/* AP[V̊mF */
	packet = smc_read_1(sc, ARR);
	if (packet & ARR_FAILED) {
		NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_OUT_ERR_PACKETS], 1);

		/* đM */
		smc_start(ic, output);
		return;
	}

	/* pPbgԍ̏ */
	smc_write_1(sc, PNR, packet);

	/* |C^I[gCNg */
	smc_write_2(sc, PTR, PTR_AUTO_INCR);

	/* 320ns҂ */
	{
		volatile UW temp;
		temp = sil_rew_mem((VP)0xA0000000);
	}

	/* MݒEMf[^̏ */
	len = output->len;
	len += PKT_CTRL_DATA_LEN;
	smc_write_2(sc, DATA0, 0);
	smc_write_2(sc, DATA0, len);

	/* NIC ւ̏ */
	data = (UH *)(output->buf + IF_ETHER_NIC_HDR_ALIGN);
	for(i = 0; i < (len >> 1); i++) {
		sil_wrh_mem((VP)(sc->smc_reg + DATA0), data[i]);
	}
	if ((len & 1) != 0)
		smc_write_2(sc, DATA0, (CTRL_ODD << 8) | data[len - 1]);
	else
		smc_write_2(sc, DATA0, 0);

	/* MỈ݂ */
	sc->smc_mask |= TX_EMPTY_INT;
	smc_write_1(sc, MSK, sc->smc_mask);

	/* pPbgM̎s */
	smc_mmu_wait(sc);
	smc_write_2(sc, SMC_MMUCR, MMUCR_CMD_ENQUEUE);

	/* M^CAEgݒ肷B*/
	ic->timer = TMO_IF_ED_XMIT;

}

/*----------------------------------------------------------------------------*/

/*
 * smc_reset -- smc lbg[NC^tF[XZbgB
 */
void
smc_reset(T_IF_SOFTC *ic)
{
	T_SMC_SOFTC	*sc = ic->sc;
	UINT		ctr;
	UH			val;
	UB			eaddr[ETHER_ADDR_LEN];
	IPM			ipm;

	/* NIC ̊荞݂֎~B*/
	ipm = ed_dis_inter();

	NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_RESETS], 1);

	/* \tgEFÃNA */
	sc->output = NULL;

	/* S݃}XN */
	smc_select_bank(sc, 2);
	sc->smc_mask = 0;
	smc_write_1(sc, MSK, 0);

	/* NIC foCXZbg */
	smc_select_bank(sc, 0);
	smc_write_2(sc, RCR, RCR_SOFT_RST);

	/* RtBO[V̐ݒ */
	smc_select_bank(sc, 1);
	smc_write_2(sc, CR, CR_EPH_POWER_EN);
	DELAY(50);

	/* pPbgM̒~ */
	smc_select_bank(sc, 0);
	smc_write_2(sc, TCR, 0);
	smc_write_2(sc, RCR, 0);

	/* Rg[WX^̐ݒ */
	smc_select_bank(sc, 1);
	ctr = smc_read_2(sc, CTR);
	ctr |= CTR_LE_ENABLE | CTR_AUTO_RELEASE;
	smc_write_2(sc, CTR, ctr);

	/* MMŨZbg */
	smc_select_bank(sc, 2);
	smc_mmu_wait(sc);
	smc_write_2(sc, SMC_MMUCR, MMUCR_CMD_MMU_RESET);

	smc_select_bank(sc, 3);
	val = smc_read_2(sc, REV);
	sc->smc_chip = (val & REV_CHIP_MASK) >> REV_CHIP_SHIFT;
	sc->smc_rev = (val * REV_REV_MASK) >> REV_REV_SHIFT;

	/* PHYRg[WX^̐ݒ */
	smc_select_bank(sc, 0);
	smc_write_2(sc, RPCR, RPCR_ANEG | (RPCR_LED_LINK_ANY << RPCR_LSA_SHIFT)
	    | (RPCR_LED_ACT_ANY << RPCR_LSB_SHIFT));

	/* pPbgM̋ */
	smc_write_2(sc, TCR, TCR_TXENA | TCR_PAD_EN);
	smc_write_2(sc, RCR, RCR_RXEN | RCR_STRIP_CRC);

	/* ݋ */
	smc_select_bank(sc, 2);
	sc->smc_mask = EPH_INT | RX_OVRN_INT | RCV_INT | TX_INT;
	smc_write_1(sc, MSK, sc->smc_mask);

	/* PHY̏ */
	smcphy_probe(ic);

	/* M\Z}tHB*/
	sig_sem(ic->semid_txb_ready);

#if TKERNEL_PRVER >= 0x1042u	/* JSP-1.4.2 ȍ~ */

	/* ^[Qbgˑ̊ݏ */
	ed_inter_init();

#endif	/* of #if TKERNEL_PRVER >= 0x1042u */

	/* NIC ̊荞݂B*/
	ed_ena_inter(ipm);
}

/*
 *  smc_get_softc -- lbg[NC^tF[X̃\tgEFAԂB
 */
T_IF_SOFTC *
smc_get_softc(void)
{
	return &if_softc;
}

/*
 * smc_watchdog -- smc lbg[NC^tF[X̃b`hbO^CAEg
 */
void
smc_watchdog(T_IF_SOFTC *ic)
{
	NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_OUT_ERR_PACKETS], 1);
	NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_TIMEOUTS], 1);

	/* NIC Zbg */
	smc_reset(ic);
}

/*
 * smc_probe -- smc lbg[NC^tF[X̌o
 */
void
smc_probe(T_IF_SOFTC *ic)
{
	T_SMC_SOFTC	*sc = ic->sc;
	UH			val;
	UB			eaddr[ETHER_ADDR_LEN];
	int			i;

#if TKERNEL_PRVER >= 0x1042u	/* JSP-1.4.2 ȍ~ */

	/* ^[Qbgˑ̃oX̏ */
	ed_bus_init();

#endif	/* of #if TKERNEL_PRVER >= 0x1042u */

	/* oNWX^ID̊mF */
	val = smc_read_2(sc, BSR);
	if ((val & BSR_IDENTIFY_MASK) != BSR_IDENTIFY) {
		return;
	}

	/* oNWX^ID̍ĊmF */
	smc_write_2(sc, BSR, 0);
	val = smc_read_2(sc, BSR);
	if ((val & BSR_IDENTIFY_MASK) != BSR_IDENTIFY) {
		return;
	}

	/* MACAhX̎擾Eݒ */
	smc_select_bank(sc, 1);
	eaddr[0] = smc_read_1(sc, IAR0);
	eaddr[1] = smc_read_1(sc, IAR1);
	eaddr[2] = smc_read_1(sc, IAR2);
	eaddr[3] = smc_read_1(sc, IAR3);
	eaddr[4] = smc_read_1(sc, IAR4);
	eaddr[5] = smc_read_1(sc, IAR5);
	for (i = 0; i < ETHER_ADDR_LEN; i ++)
		ic->ifaddr.lladdr[i] = eaddr[i];

}

/*
 * smc_init -- smc lbg[NC^tF[X̏
 */
void
smc_init(T_IF_SOFTC *ic)
{
	T_SMC_SOFTC	*sc = ic->sc;
	IPM	ipm;

	/* NIC ̊荞݂֎~B*/
	ipm = ed_dis_inter();

	smc_reset(ic);

#if TKERNEL_PRVER >= 0x1042u	/* JSP-1.4.2 ȍ~ */

	/* ^[Qbgˑ̊ݏ */
	ed_inter_init();

#endif	/* of #if TKERNEL_PRVER >= 0x1042u */

	/* NIC ̊荞݂B*/
	ed_ena_inter(ipm);
}

/*
 * smc_read -- t[̓ǂݍ
 */
T_NET_BUF *
smc_read(T_IF_SOFTC *ic)
{
	T_SMC_SOFTC	*sc = ic->sc;
	UINT		packet, status, len;
	UINT 		i;
	UH			*data;
	UB			*ptr;
	T_NET_BUF	*input = NULL;
	UH			sublen, align;
	ER			error;
	IPM			ipm;


	/* NIC ̊荞݂֎~B*/
	ipm = ed_dis_inter();

	/* oNؑ */
	smc_select_bank(sc, 2);

	/* MFIFO̊mF */
	packet = smc_read_1(sc, FIFO_RX);
	if ((packet & FIFO_EMPTY) == 0) {

		/* |C^M[hݒ */
		smc_write_2(sc, PTR, PTR_READ | PTR_RCV | PTR_AUTO_INCR);

		/* 320ns҂ */
		{
			volatile UW temp;
			temp = sil_rew_mem((VP)0xA0000000);
		}

		/* MpPbgXeC^XEf[^̎擾 */
		status = smc_read_2(sc, DATA0);
		len = smc_read_2(sc, DATA0) & RX_LEN_MASK;
		len -= 6;
		if (status & RX_ODDFRM)
			len += 1;

		/* MpPbgG[`FbN */
		if (status & (RX_TOOSHORT | RX_TOOLNG | RX_BADCRC | RX_ALGNERR)) {
			smc_mmu_wait(sc);
			smc_write_2(sc, SMC_MMUCR, MMUCR_CMD_RELEASE);

			/* MG[ƃZbgL^B*/
			NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_IN_ERR_PACKETS], 1);
			NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_RESETS], 1);

			/* M݋ */
			sc->smc_mask |= RCV_INT;
			smc_write_1(sc, MSK, sc->smc_mask);

			/* NIC ̊荞݂B*/
			ed_ena_inter(ipm);

			return NULL;
		}

		/*
		 *  +-----------+--------+---------+---------+
		 *  | Ehter HDR | IP HDR | TCP HDR | TCP SDU |
		 *  +-----------+--------+---------+---------+
		 *        14        20        20        n
		 *   <----------------- len ---------------->
		 *              ^
		 *              t_net_buf  4 INebgEɃACĂB
		 *
		 *  tcp_input  udp_input ł́A[wb_ SDU Ń`FbNT
		 *  vZ邪An  4 INebgEɂȂ悤 SDU ̌ 0 
		 *  pbfBOB̕l net_buf lȂ΂ȂȂB
		 */
		align = ((((len - sizeof(T_IF_HDR)) + 3) >> 2) << 2) + sizeof(T_IF_HDR);
		if ((error = tget_net_buf(&input, align, TMO_IF_ED_GET_NET_BUF)) == E_OK && input != NULL) {
			NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_IN_PACKETS], 1);
			NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_IN_OCTETS],  len);

			ptr = input->buf + IF_ETHER_NIC_HDR_ALIGN;
			data = (UH *) ptr;

			/* NIC ̓Ǎ */
			for(i = 0; i < (len >> 1); i++) {
				data[i] = sil_reh_mem((VP)(sc->smc_reg + DATA0));
			}
			if (len & 1) {
				ptr += len & ~1;
				*ptr = smc_read_1(sc, DATA0);
			}
		}

		/* MFIFO̊J */
		smc_mmu_wait(sc);
		smc_write_2(sc, SMC_MMUCR, MMUCR_CMD_RELEASE);

		packet = smc_read_1(sc, FIFO_RX);
	}

	/* M݋ */
	sc->smc_mask |= RCV_INT;
	smc_write_1(sc, MSK, sc->smc_mask);

	/* NIC ̊荞݂B*/
	ed_ena_inter(ipm);

	return input;
}

/*
 * smc_start -- Mt[obt@OB
 */
void
smc_start(T_IF_SOFTC *ic, T_NET_BUF *output)
{
	T_SMC_SOFTC	*sc = ic->sc;
	UINT		packet;
	UB			*data;
	UINT		npages, spin_count;
	IPM			ipm;

	NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_OUT_PACKETS], 1);
	NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_OUT_OCTETS],  output->len);

	/* NIC ̊荞݂֎~B*/
	ipm = ed_dis_inter();

	smc_select_bank(sc, 2);

	/* pPbgy[WTCY̎擾iy[WF256oCgj */
	npages = (output->len * PKT_CTRL_DATA_LEN) >> 8;
	if (npages == 0)
		npages = 1;

	/* M̎擾 */
	smc_select_bank(sc, 2);
	smc_mmu_wait(sc);
	smc_write_2(sc, SMC_MMUCR, MMUCR_CMD_TX_ALLOC | npages);

	/* M擾̊mF */
	spin_count = TX_ALLOC_WAIT_TIME;
	do {
		if (smc_read_1(sc, IST) & ALLOC_INT) {
			smc_write_1(sc, ACK, ALLOC_INT);
			break;
		}
	} while (--spin_count);

	/* 擾݂̋ */
	sc->smc_mask |= ALLOC_INT;
	smc_write_1(sc, MSK, sc->smc_mask);

	sc->output = output;

	/* NIC ̊荞݂B*/
	ed_ena_inter(ipm);
}

/*
 *  if_smc_handler -- NIC 荞݃nh
 */
void
if_smc_handler(void)
{
	T_SMC_SOFTC	*sc;
	T_IF_SOFTC 	*ic;
	UH			status;
	UH			tx_status;
	UH			packet;
	UH			counter;
	UH			tcr;
	UH			collisions;

	ic = &if_softc;
	sc = ic->sc;

	/* oNؑ */
	smc_select_bank(sc, 2);

	/* ݋֎~ */
	smc_write_1(sc, MSK, 0);

	/* ݃XeC^X̎擾 */
	status = smc_read_1(sc, IST) & sc->smc_mask;

	/* MG[ */
	if (status & TX_INT) {
		NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_OUT_ERR_PACKETS], 1);

		/* MFIFO̊mF */
		packet = smc_read_1(sc, FIFO_TX);
		if ((packet & FIFO_EMPTY) == 0) {
			/* pPbgԍ̍Đݒ */
			smc_write_1(sc, PNR, packet);

			/* MFIFOXeC^X̎擾 */
			smc_write_2(sc, PTR, PTR_READ | PTR_AUTO_INCR);
			/* 320ns҂ */
			{
				volatile UW temp;
				temp = sil_rew_mem((VP)0xA0000000);
			}
			tx_status = smc_read_2(sc, DATA0);

			/* pPbg̊J */
			smc_mmu_wait(sc);
			smc_write_2(sc, SMC_MMUCR, MMUCR_CMD_RELEASE_PKT);

			/* MRg[WX^̍Đݒ */
			smc_select_bank(sc, 0);
			tcr = smc_read_2(sc, TCR);
			tcr |= TCR_TXENA | TCR_PAD_EN;
			smc_write_2(sc, TCR, tcr);

			/* oNؑ */
			smc_select_bank(sc, 2);
		}

		/* MG[݂̃NA */
		smc_write_1(sc, ACK, TX_INT);
	}

	/* pPbgM */
	if (status & RCV_INT) {
		/* M݂̃NA */
		smc_write_1(sc, ACK, RCV_INT);

		/* M݋֎~ */
		sc->smc_mask &= ~RCV_INT;

		/* M^XNւ̒ʒm */
		if (isig_sem(ic->semid_rxb_ready) != E_OK) {
			NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_RXB_QOVRS], 1);
		}
	}

	/* M擾 */
	if (status & ALLOC_INT) {
		/* M擾݋֎~ */
		smc_write_1(sc, ACK, ALLOC_INT);

		/* M擾݋֎~ */
		sc->smc_mask &= ~ALLOC_INT;

		/* M */
		smc_tx(ic, sc->output);

		/* M^XNւ̒ʒm */
//		if (isig_sem(ic->semid_txb_ready) != E_OK)
//			NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_TXB_QOVRS], 1);
	}

	/* MpPbgI[o[G[ */
	if (status & RX_OVRN_INT) {
		/* MpPbgI[o[G[݂̃NA */
		smc_write_1(sc, ACK, RX_OVRN_INT);

		/* MG[L^B*/
		NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_IN_ERR_PACKETS], 1);
	}

	/* MFIFOGveBiMIj */
	if (status & TX_EMPTY_INT) {
		/* MFIFOGveB݂̃NA */
		smc_write_1(sc, ACK, TX_EMPTY_INT);

		/* MFIFOGveB݋֎~ */
		sc->smc_mask &= ~TX_EMPTY_INT;

		/* Փ˔̊mF */
		smc_select_bank(sc, 0);
		counter = smc_read_2(sc, ECR);
		smc_select_bank(sc, 2);

		/* Փˉ񐔂̎擾 */
		collisions = (counter & ECR_SNGLCOL_MASK) >> ECR_SNGLCOL_SHIFT;

		/* M^CAEgZbgB*/
		ic->timer = 0;

		/* M^XNւ̒ʒm */
		if (isig_sem(ic->semid_txb_ready) != E_OK)
			NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_TXB_QOVRS], 1);

		/* Փˉ񐔂L^B*/
		NET_COUNT_ETHER_NIC(net_count_ether_nic[NC_ETHER_NIC_COLS], collisions);
	}

	/* ݋ */
	smc_write_1(sc, MSK, sc->smc_mask);
}

/*----------------------------------------------------------------------------*/

/*
 * smc_mii_readbits -- MIIrbgǍ
 */
static UINT
smc_mii_readbits(T_SMC_SOFTC *sc, int nbits)
{
	UINT	mgmt, mask, val;

	/* MIIWX^ݒ */
	mgmt = smc_read_2(sc, MGMT) & ~(MGMT_MCLK | MGMT_MDOE | MGMT_MDO);
	smc_write_2(sc, MGMT, mgmt);

	/* rbgǍ */
	for (mask = 1 << (nbits - 1), val = 0; mask; mask >>= 1) {
		if (smc_read_2(sc, MGMT) & MGMT_MDI)
			val |= mask;

		smc_write_2(sc, MGMT, mgmt);
		DELAY(50);
		smc_write_2(sc, MGMT, mgmt | MGMT_MCLK);
		DELAY(50);
	}

	return (val);
}

/*
 * smc_mii_readbits -- MIIrbg
 */
static void
smc_mii_writebits(T_SMC_SOFTC *sc, UINT val, int nbits)
{
	UINT	mgmt, mask;

	/* MIIWX^ݒ */
	mgmt = smc_read_2(sc, MGMT) & ~(MGMT_MCLK | MGMT_MDOE | MGMT_MDO);
	mgmt |= MGMT_MDOE;

	/* rbg */
	for (mask = 1 << (nbits - 1); mask; mask >>= 1) {
		if (val & mask)
			mgmt |= MGMT_MDO;
		else
			mgmt &= ~MGMT_MDO;

		smc_write_2(sc, MGMT, mgmt);
		DELAY(50);
		smc_write_2(sc, MGMT, mgmt | MGMT_MCLK);
		DELAY(50);
	}
}

/*
 * smc_miibus_readreg -- MIIWX^Ǎ
 */
static UINT
smc_miibus_readreg(T_SMC_SOFTC *sc, int phy, int reg)
{
	UINT			val;

	smc_select_bank(sc, 3);

	/* AChp^[̑M */
	smc_mii_writebits(sc, 0xffffffff, 32);

	/* JnR[h + IyR[h + PHYAhX + PHYWX^ */
	smc_mii_writebits(sc, 6 << 10 | phy << 5 | reg, 14);

	/* ^[AEh + f[^ */
	val = smc_mii_readbits(sc, 18);

	/* MDIOC^tF[X̃Zbg */
	smc_write_2(sc, MGMT,
	    smc_read_2(sc, MGMT) & ~(MGMT_MCLK | MGMT_MDOE | MGMT_MDO));

	return (val);
}

/*
 * smc_miibus_writereg -- MIIWX^
 */
static void
smc_miibus_writereg(T_SMC_SOFTC *sc, int phy, int reg, UINT data)
{
	smc_select_bank(sc, 3);

	/* AChp^[̑M */
	smc_mii_writebits(sc, 0xffffffff, 32);


	/* JnR[h + IyR[h + PHYAhX + PHYWX^ + 
		^[AEh + f[^ */
	smc_mii_writebits(sc, 5 << 28 | phy << 23 | reg << 18 | 2 << 16 | data,
	    32);

	/* MDIOC^tF[X̃Zbg */
	smc_write_2(sc, MGMT,
	    smc_read_2(sc, MGMT) & ~(MGMT_MCLK | MGMT_MDOE | MGMT_MDO));

}

/*
 * smcphy_reset -- PHYZbg
 */
static int
smcphy_reset(T_SMC_SOFTC *sc)
{
	UINT	bmcr;
	int		timeout;

	/* PHYZbg̎s */
	smc_miibus_writereg(sc, sc->phy_addr, MII_BMCR, BMCR_RESET);

	/* PHYZbg̏ImF */
	for (timeout = 20; timeout > 0; timeout--) {
		dly_tsk(500);
		bmcr = smc_miibus_readreg(sc, sc->phy_addr,  MII_BMCR);
		if ((bmcr & BMCR_RESET) == 0)
			break;
	}

	if (bmcr & BMCR_RESET) {
		return -1;
	}

	return (0);
}

/*
 * smcphy_probe -- PHY̐ݒ
 */
static int
smcphy_probe(T_IF_SOFTC *ic)
{
	T_SMC_SOFTC	*sc;
	UINT		bmcr;
	UINT		anar;
	UINT		lpa;
	UINT		caps;
	UH			tcr;

	sc = ic->sc;

	/* PHYZbg̎s */
	if (smcphy_reset(sc) != 0) {
		return (-1);
	}

	/* PHY݂̋֎~ */
	smc_miibus_writereg(sc, sc->phy_addr, 0x1e, 0xffc0);

	/* PHYRg[WX^̐ݒ */
	smc_select_bank(sc, 0);
	smc_write_2(sc, RPCR, RPCR_ANEG | (RPCR_LED_LINK_ANY << RPCR_LSA_SHIFT)
	    | (RPCR_LED_ACT_ANY << RPCR_LSB_SHIFT));

	/* PHYXeC^X̎擾 */
	caps = smc_miibus_readreg(sc, sc->phy_addr,  MII_BMSR);

	/* I[glSVG[VWX^̐ݒ */
	anar = BMSR_MEDIA_TO_ANAR(caps) | ANAR_CSMA;
	smc_miibus_writereg(sc, sc->phy_addr, MII_ANAR, anar);

	/* PHYRg[WX^̐ݒ */
	anar = smc_miibus_readreg(sc, sc->phy_addr, MII_ANAR);
	smc_miibus_writereg(sc, sc->phy_addr, MII_BMCR, BMCR_AUTOEN | BMCR_STARTNEG);

	/* MRg[WX^̎擾 */
	smc_select_bank(sc, 0);
	tcr = smc_read_2(sc, TCR);

	/* PHYNݒ̎擾 */
	anar = smc_miibus_readreg(sc, sc->phy_addr, MII_ANAR);
	lpa = smc_miibus_readreg(sc, sc->phy_addr, MII_ANLPAR);

	/* dESd[h̐ݒ */
	anar = anar & lpa;
	if(anar & (ANAR_CSMA | ANAR_TX_FD | ANAR_10_FD))
		tcr |= TCR_SWFDUP;
	else
		tcr &= ~TCR_SWFDUP;
	smc_write_2(sc, TCR, tcr);

	return (0);
}
