/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2007 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: tcp_output.c,v 1.4 2007/11/09 00:43:30 abe Exp abe $
 */

/*
 * Copyright (c) 1982, 1986, 1988, 1990, 1993, 1995
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)tcp_output.c	8.4 (Berkeley) 5/24/95
 * $FreeBSD: src/sys/netinet/tcp_output.c,v 1.32.2.2 1999/08/29 16:29:55 peter Exp $
 */

#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/if.h>
#include <net/if_ppp.h>
#include <net/if_loop.h>
#include <net/ethernet.h>
#include <net/net.h>
#include <net/net_buf.h>
#include <net/net_timer.h>
#include <net/net_count.h>

#include <netinet/in.h>
#include <netinet6/in6.h>
#include <netinet/in_var.h>
#include <netinet/in_itron.h>
#include <netinet/ip.h>
#include <netinet/ip_var.h>
#include <netinet6/in6_var.h>
#include <netinet/ip6.h>
#include <netinet6/ip6_var.h>
#include <netinet/tcp.h>
#include <netinet/tcp_timer.h>
#include <netinet/tcp_var.h>
#include <netinet/tcp_fsm.h>
#include <netinet/tcp_seq.h>

#ifdef SUPPORT_TCP

/*
 *  ؿ
 */

static ER send_segment (BOOL *sendalot, T_TCP_CEP *cep, UINT doff, UINT win, UINT len, UB flags);
static void tcp_output (T_TCP_CEP *cep);

/*
 *  ѿ
 */

/* ϻΥե饰 FSM ֤ˤ򤹤뤿ɽ */

const static UB tcp_outflags[] = {
	TCP_FLG_RST | TCP_FLG_ACK,	/*  0, 				*/
	0,				/*  1, ưץ			*/
	TCP_FLG_SYN,			/*  2, ǽưץSYN Ѥ	*/
	TCP_FLG_SYN | TCP_FLG_ACK,	/*  3, SYM SYN Ѥ	*/
	TCP_FLG_ACK,			/*  4, ͥߴλ		*/
	TCP_FLG_ACK,			/*  5, FIN Ԥ		*/
	TCP_FLG_FIN | TCP_FLG_ACK,	/*  6, λơFIN Ѥ		*/
	TCP_FLG_FIN | TCP_FLG_ACK,	/*  7, λFIN 򴹺ѤߡACK Ԥ	*/
	TCP_FLG_FIN | TCP_FLG_ACK,	/*  8, FIN λACK Ԥ		*/
	TCP_FLG_ACK,			/*  9, λFIN ãǧFINԤ	*/
	TCP_FLG_ACK,			/* 10, λԤ			*/
	};

/*
 *  send_segment -- TCP Ͻ
 */

static ER
send_segment (BOOL *sendalot, T_TCP_CEP *cep, UINT doff, UINT win, UINT len, UB flags)
{
	T_NET_BUF	*output;
	T_TCP_HDR	*tcph;
	UINT		optlen;
	ER		error;

#ifdef TCP_CFG_OPT_MSS

	UB		*optp;

	if (flags & TCP_FLG_SYN)
		optlen = TCP_OPT_LEN_MAXSEG;
	else
		optlen = 0;

#else/* of #ifdef TCP_CFG_OPT_MSS */

	optlen = 0;

#endif/* of #ifdef TCP_CFG_OPT_MSS */

	NET_COUNT_TCP(net_count_tcp[NC_TCP_SEND_SEGS], 1);
	NET_COUNT_MIB(tcp_stats.tcpOutSegs, 1);

	/*
	 *  ĹκĹĴ롣
	 *  ⤷ĶƤϡĶʬ롣
	 *  ΤᡢFIN ӥåȤ򥯥ꥢ롣
	 *
	 *  ꥸʥǤϡt_maxopd ĹˤƤ뤬
	 *  ܼǤϡκȤˤ롣
	 */
	if (len + optlen > cep->maxseg) {
		flags &= ~TCP_FLG_FIN;
		len = cep->maxseg - (len + optlen);
		*sendalot = TRUE;
		}

	/*
	 *  ХåեˤʤȤ PUSH ե饰ꤹ롣
	 */
	if (len && doff + len >= cep->swbuf_count)
		flags |= TCP_FLG_PUSH;

#if defined(TCP_CFG_SWBUF_CSAVE_ONLY)
		
	if (len > 0 && ((cep->flags & TCP_CEP_FLG_WBCS_MASK) == TCP_CEP_FLG_WBCS_SEND_READY ||
	                (cep->flags & TCP_CEP_FLG_WBCS_MASK) == TCP_CEP_FLG_WBCS_SENT)) {

		/*
		 *  ɥХåեʤ褦ˤơ
		 *  ͥåȥХåեϤ˰ܤ
		 */
		cep->swbufq->flags |= NB_FLG_NOREL_IFOUT;
		output = cep->swbufq; 
		}
	else {

		/*
		 *  ACK λ֤ǡδؿƤӽФ뤳Ȥ⤢롣
		 *  λϡlen  0 ˤơ³롣
		 */
		len = 0;
		if ((error = tcp_get_segment(&output, cep, optlen,
	                                    len, (UINT)(net_buf_max_siz() - IF_IP_TCP_HDR_SIZE),
	                                    NBA_SEARCH_ASCENT, TMO_TCP_GET_NET_BUF)) != E_OK)
			goto err_ret;
		}

#elif defined(TCP_CFG_SWBUF_CSAVE)	/* of #if defined(TCP_CFG_SWBUF_CSAVE_ONLY) */

	if (IS_PTR_DEFINED(cep->sbuf)) {
		if ((error = tcp_get_segment(&output, cep, optlen,
		                             len, (UINT)(net_buf_max_siz() - IF_IP_TCP_HDR_SIZE),
		                             NBA_SEARCH_ASCENT, TMO_TCP_GET_NET_BUF)) != E_OK) {
			goto err_ret;
			}
		}
	else if (len > 0 && ((cep->flags & TCP_CEP_FLG_WBCS_MASK) == TCP_CEP_FLG_WBCS_SEND_READY ||
	                     (cep->flags & TCP_CEP_FLG_WBCS_MASK) == TCP_CEP_FLG_WBCS_SENT)) {

		/*
		 *  ɥХåեʤ褦ˤơ
		 *  ͥåȥХåեϤ˰ܤ
		 */
		cep->swbufq->flags |= NB_FLG_NOREL_IFOUT;
		output = cep->swbufq; 
		}
	else {

		/*
		 *  ACK λ֤ǡδؿƤӽФ뤳Ȥ⤢롣
		 *  λϡlen  0 ˤơ³롣
		 */
		len = 0;
		if ((error = tcp_get_segment(&output, cep, optlen,
	                                    len, (UINT)(net_buf_max_siz() - IF_IP_TCP_HDR_SIZE),
	                                    NBA_SEARCH_ASCENT, TMO_TCP_GET_NET_BUF)) != E_OK)
			goto err_ret;
		}

#else	/* of #if defined(TCP_CFG_SWBUF_CSAVE_ONLY) */

	if ((error = tcp_get_segment(&output, cep, optlen,
	                             len, (UINT)(net_buf_max_siz() - IF_IP_TCP_HDR_SIZE),
	                             NBA_SEARCH_ASCENT, TMO_TCP_GET_NET_BUF)) != E_OK) {
		goto err_ret;
		}

#endif	/* of #if defined(TCP_CFG_SWBUF_CSAVE_ONLY) */

	/*
	 *  TCP ץԤ
	 *  ܼǤϡ祻ȥΤꤹ롣
	 */
	if (flags & TCP_FLG_SYN) {
		cep->snd_nxt = cep->iss;

#ifdef TCP_CFG_OPT_MSS

		optp = GET_TCP_OPT(output, IF_IP_TCP_HDR_OFFSET);
		*optp ++ = TCP_OPT_MAXSEG;
		*optp ++ = TCP_OPT_LEN_MAXSEG;
		*(UH*)optp = htons(DEF_TCP_RCV_SEG);

#endif/* of #ifdef TCP_CFG_OPT_MSS */

		}

	/* TCP SDU ǡ򥳥ԡ롣*/

	if (len > 0) {
		if (SEQ_LT(cep->snd_nxt, cep->snd_max)) {
			NET_COUNT_TCP(net_count_tcp[NC_TCP_SEND_REXMIT_SEGS], 1);
			NET_COUNT_MIB(tcp_stats.tcpRetransSegs, 1);
			}
		TCP_READ_SWBUF(cep, output, len, doff);
		}
	else {
		if (cep->flags & TCP_CEP_FLG_ACK_NOW)
			NET_COUNT_TCP(net_count_tcp[NC_TCP_SEND_ACKS], 1);
		if (flags & (TCP_FLG_FIN | TCP_FLG_SYN | TCP_FLG_RST))
			NET_COUNT_TCP(net_count_tcp[NC_TCP_SEND_CNTL_SEGS],  1);


#ifdef TCP_CFG_EXTENTIONS

		if (SEQ_LT(cep->snd_up, cep->snd_una))
			NET_COUNT_TCP(net_count_tcp[NC_TCP_SEND_URG_SEGS], 1);

#endif	/* of #ifdef TCP_CFG_EXTENTIONS */

		}

	/*
	 * snd_max:  SEQ
	 * snd_nxt:  SEQ
	 *
	 *  ꤫ FIN ޤ FIN Ƥʤ
	 *  ǡʤȤϡFIN Ϥ뤿ᡢ
	 *  Ȥ뤬SEQ Ͽʤʤ
	 */
	if ((flags & TCP_FLG_FIN) && (cep->flags & TCP_CEP_FLG_SENT_FIN) &&
	    cep->snd_nxt == cep->snd_max) {
		cep->snd_nxt --;
		}

	tcph = GET_TCP_HDR(output, IF_IP_TCP_HDR_OFFSET);

	/*
	 *  SEQACKե饰ꡣ
	 */
	if (len > 0 || (flags & (TCP_FLG_SYN | TCP_FLG_FIN)) || cep->timer[TCP_TIM_PERSIST] != 0)
		tcph->seq = htonl(cep->snd_nxt);
	else
		tcph->seq = htonl(cep->snd_max);

	/*
	 *  rcv_nxt: ԤƤǾ SEQ
	 */
	tcph->ack   = htonl(cep->rcv_nxt);
	tcph->flags = flags;

	/*
	 *  ɤη׻
	 *
	 *  rbufsz: ѥХåե
	 *  maxseg: κȥ	
	 */
	if (win < (cep->rbufsz / 4) && win < cep->maxseg)
		win = 0;

	/*
	 *  rcv_nxt: ԤƤǾ SEQ
	 *  rcv_adv: ԤƤ SEQ
	 */
	if ((W)win < (W)(cep->rcv_adv - cep->rcv_nxt))
		win = (UINT)(cep->rcv_adv - cep->rcv_nxt);

	tcph->win = htons(win);

#ifdef TCP_CFG_EXTENTIONS

	/*
	 *  ۵ޥݥ󥿤
	 */
	if (SEQ_GT(cep->snd_up, cep->snd_nxt)) {
		if (TCP_CFG_URG_OFFSET)
			tcph->urp    = htons((UH)(cep->snd_up - cep->snd_nxt));
		else
			tcph->urp    = htons((UH)(cep->snd_up - cep->snd_nxt - 1));
		tcph->flags |= TCP_FLG_URG;
		}
	else
		cep->snd_up  = cep->snd_una;

#endif	/* of #ifdef TCP_CFG_EXTENTIONS */

	/*
	 *  åꤹ롣
	 */
	tcph->sum = 0;
	tcph->sum = IN_CKSUM(output, IPPROTO_TCP, (UINT)GET_TCP_HDR_OFFSET(output),
		             GET_TCP_HDR_SIZE2(output, IF_IP_TCP_HDR_OFFSET) + len);

	/* ͥåȥХåեĹĴ롣*/
	output->len = (UH)(GET_IF_IP_TCP_HDR_SIZE2(output, IF_IP_TCP_HDR_OFFSET) + len);

	/*
	 *  ޤĴ
	 */
	if ((cep->flags & TCP_CEP_FLG_FORCE) == 0 || cep->timer[TCP_TIM_PERSIST] == 0) {
		T_TCP_SEQ startseq = cep->snd_nxt;

		/*
		 *   SEQ (snd_nxt) 򺣲ǡʬʤ롣
		 */
		if (flags & TCP_FLG_SYN)
			cep->snd_nxt ++;
		if (flags & TCP_FLG_FIN) {
			cep->flags |= TCP_CEP_FLG_SENT_FIN;
			cep->snd_nxt ++;
			}

		cep->snd_nxt += len;

		/*
		 *   SEQ (snd_nxt) 
		 *   SEQ (snd_max) ʤǤС
		 *   SEQ (snd_max) 򹹿롣
		 */
		if (SEQ_GT(cep->snd_nxt, cep->snd_max)) {
			cep->snd_max = cep->snd_nxt;
			/*
			 *  ⤷ַ¬ԤäƤʤС
			 *  ˻֤碌롣
			 */
			if (cep->rtt == 0) {
				cep->rtt   = 1;
				cep->rtseq = startseq;	/*  cep->snd_nxt */
				}
			}

		/*
		 *  ⤷ꤵƤʤACK ޤαȯƤʤС
		 *  ޤꤹ롣ꤹͤϡ
		 * ֳ餫ʱ + 2  ưפǤ롣
		 *  ֤ΥХåդ˻Ȥ륷եȥȤ롣
		 */
		if (cep->timer[TCP_TIM_REXMT] == 0 && cep->snd_nxt != cep->snd_una) {
			cep->timer[TCP_TIM_REXMT] = cep->rxtcur;
			if (cep->timer[TCP_TIM_PERSIST] != 0) {
				cep->timer[TCP_TIM_PERSIST] = 0;
				cep->rxtshift = 0;
				}
			}
		}

	/*
	 *   SEQ (snd_nxt) + ǡ (len) 
	 *   SEQ (snd_max) ʤǤС
	 *   SEQ (snd_max) 򹹿롣
	 */
	else if (SEQ_GT(cep->snd_nxt + len, cep->snd_max))
		cep->snd_max = cep->snd_nxt + len;

#ifdef TCP_CFG_SWBUF_CSAVE

	if ((cep->flags & TCP_CEP_FLG_WBCS_MASK) == TCP_CEP_FLG_WBCS_SEND_READY)
		cep->flags = (cep->flags & ~TCP_CEP_FLG_WBCS_MASK) | TCP_CEP_FLG_WBCS_SENT;

#endif	/* of #ifdef TCP_CFG_SWBUF_CSAVE */

#ifdef TCP_CFG_TRACE

	tcp_output_trace(output, cep);

#endif	/* of #ifdef TCP_CFG_TRACE */

	/* ͥåȥ (IP) νϴؿƤӽФ*/
	if ((error = IP_OUTPUT(output, TMO_TCP_OUTPUT)) != E_OK)
		goto err_ret;

	/*
	 *  ɥ (win)  0 ʾǡ
	 *  ԤƤǾ SEQ (rcv_nxt) + win 
	 *  ԤƤ SEQ (rcv_adv) ʤǤ
	 *  ԤƤ SEQ 򹹿롣
	 */
	if (win > 0 && SEQ_GT(cep->rcv_nxt + win, cep->rcv_adv)) {
		cep->rcv_adv = cep->rcv_nxt + win;
		}

	/*
	 *  Ǹ ACK (last_ack_sent) 򹹿롣
	 */
	cep->last_ack_sent = cep->rcv_nxt;

	/*
	 *  ե饰Ԥ
	 */
	cep->flags &= ~(TCP_CEP_FLG_ACK_NOW | TCP_CEP_FLG_DEL_ACK);
	if (cep->flags & TCP_CEP_FLG_FORCE_CLEAR)
		cep->flags &= ~(TCP_CEP_FLG_FORCE | TCP_CEP_FLG_FORCE_CLEAR);

	return E_OK;

err_ret:
	/*
	 * ʲ˴طʤե饰򥯥ꥢ롣
	 * ɥХåեξʥԡǽ
	 * ưŪ̿üǽ
	 */
	cep->flags &= (TCP_CEP_FLG_WBCS_NBUF_REQ | TCP_CEP_FLG_WBCS_MASK | 
	               TCP_CEP_FLG_DYNAMIC       | TCP_CEP_FLG_VALID);

	return error;
	}

/*
 *  tcp_output -- TCP Ͻ
 */

void
tcp_output (T_TCP_CEP *cep)
{
	W	len;
	UINT	doff, win;
	BOOL	sendalot = TRUE, idle;
	ER	error = E_OK;
	UB	flags;

	/*
	 *  snd_una: ̤ǧκǾ SEQ	 ޤϡǧ줿 SEQ
	 *  snd_max:  SEQ
	 */
	idle = (cep->snd_max == cep->snd_una);

	/*
	 *  idle:   ɥ
	 *  rxtcur: ߤκॢ
	 */
	if (idle && cep->idle >= cep->rxtcur)

		/*
		 *  snd_cwnd: ԥɥ
		 *  maxseg  : κȥ
		 *
		 *  Ĺ֥ɥäΤǥꤹ롣
		 */
		cep->snd_cwnd = cep->maxseg;

	while (error == E_OK && sendalot) {
		sendalot = FALSE;

		/*
		 *  snd_nxt:  SEQλǤϡ SEQ
		 *  snd_una: ̤ǧκǾ SEQޤϳǧ줿 SEQ
		 *
		 *  doff: 򳫻Ϥ륪եåȡ
		 *                                    swbuf_count (Хåեˤ륪ƥåȿ)
		 *    0                               V
		 *    +-------------------------------------------+
		 *    |                    sbuf                   |
		 *    +-------------------------------------------+
		 *    ^               ^
		 *    |<------------->snd_nxt ( SEQ)
		 *    |       doff
		 *    snd_una (ޤǧƤʤ)
		 */
		doff = (UINT)(cep->snd_nxt - cep->snd_una);

		/*
		 *  snd_wnd:  μǽɥ
		 *  snd_cwnd: ԥɥ
		 *
		 *  win: ɤ餫ɥꤹ롣
		 */
		win   = cep->snd_wnd < cep->snd_cwnd ? cep->snd_wnd : cep->snd_cwnd;
	
		/* ϥե饰 */
		flags = tcp_outflags[cep->fsm_state];
		if (cep->flags & TCP_CEP_FLG_NEED_FIN)
			flags |= TCP_FLG_FIN;
		if (cep->flags & TCP_CEP_FLG_NEED_SYN)
			flags |= TCP_FLG_SYN;
		if (cep->flags & TCP_CEP_FLG_FORCE) {

			/*
			 *  ⤷ɥ (win)  0 ʤ 1 ƥå롣
			 *  ǤʤС³ॢȤ򥭥󥻥뤷
			 *   (rxtshift)  0 ˤ롣
			 */
			if (win == 0) {

				/*
				 *  doff:        륪ƥåȿ
				 *  swbuf_count: Хåեλ極
				 *
				 *  Хåե˻ĤäƤ륪ƥåȤ줫
				 *  褦ȤƤ륪ƥåȿ¿
				 *  FIN ե饰򥯥ꥢ롣
				 */
				if (doff < cep->swbuf_count)
					flags &=~TCP_FLG_FIN;
				win = 1;
				}
			else {
				/*
				 *  TCP_TIM_PERSIST: ³
				 *  rxtshift:         log(2)
				 */
				cep->timer[TCP_TIM_PERSIST] = 0;
				cep->rxtshift = 0;
				}
		 	}

		/*
		 *  len: 륪ƥåȿ
		 *        swbuf_count (Хåեˤ륪ƥåȿ)
		 *                                    |
		 *    0                               V
		 *    +-------------------------------------------+
		 *    |                    sbuf       |           |
		 *    +-------------------------------------------+
		 *    ^               ^<------------->
		 *    |               |      len
		 *    |<------------->snd_nxt ( SEQ)
		 *    |       doff
		 *    snd_una (ޤǧƤʤ)
		 */
		if (cep->swbuf_count < win)
			len = (W)cep->swbuf_count - doff;
		else
			len = (W)win - doff;

		/*
		 *  ǤƤСSYN ӥåȤ򥪥դ롣
		 *  ʲξǤ򹵤롣
		 *
		 *    ֤ SYN 
		 *    ȤǡޤǤ롣
		 */
		if ((flags & TCP_FLG_SYN) && SEQ_GT(cep->snd_nxt, cep->snd_una)) {
			flags &= ~TCP_FLG_SYN;
			doff --;		/* -1  SYN ե饰ʬ */
			len ++;			/* +1  SYN ե饰ʬ */
			if (len > 0 && cep->fsm_state == TCP_FSM_SYN_SENT)
				break;
			}

		if (flags & TCP_FLG_SYN) {
			len = 0;
			flags &= ~TCP_FLG_FIN;
			}

		if (len < 0) {

			/*
			 *  len  0 ʲʤ顢0 ꤹ롣
			 *  ⤷ɥ 0 ʤ顢
			 *  ޤ򥭥󥻥뤷
			 *   SEQ (snd_nxt) 
			 *  ǧ줿 SEQ (snd_una) ᤹
			 *  ơ³ޡߤޤäƤСꤹ롣
			 */
			len = 0;
			if (win == 0) {
				cep->timer[TCP_TIM_REXMT] = 0;
				cep->rxtshift = 0;
				cep->snd_nxt  = cep->snd_una;
				if (cep->timer[TCP_TIM_PERSIST] == 0)
					tcp_set_persist_timer(cep);
				}
			}


		/*
		 *  륪ƥåȿ (len) ϡ
		 *  κȥ (maxseg) Ķʤ褦ˤ롣
		 */
		if (len > cep->maxseg) {
			len = cep->maxseg;
			sendalot = TRUE;
			}

		/*
                 *        swbuf_count (Хåեˤ륪ƥåȿ)
                 *                                           |
		 *    0                                      V
		 *    +-------------------------------------------+
		 *    |                    sbuf       |           |
		 *    +-------------------------------------------+
		 *    ^               ^<------------->
		 *    |               |      len
		 *    |<------------->snd_nxt ( SEQ)
		 *    |       doff
		 *    snd_una (ޤǧƤʤ)
		 *
		 *  ⡢Хåե˥ǡĤäƤ
		 *  FIN ե饰򥯥ꥢ롣
		 */
		if (SEQ_LT(cep->snd_nxt + len, cep->snd_una + cep->swbuf_count))
			flags &= ~TCP_FLG_FIN;

		/*
		 *   win ϡɥ
		 *  Хåեζ
		 */
		win = cep->rbufsz - cep->rwbuf_count;

		/*
		 *  򤫤ʥɥɥβ (¦)
		 *
		 *  ʲξǡԤ
		 *
		 *    ե륵 (maxseg) ΥȤ뤳ȤǤ롣
		 *    κμɥ 1/2 Υǡ
		 *      뤳ȤǤ롣
		 *    ХåեˤǤɥ뤫ٱ䥪ץͭʤȤ
		 */
		if (len) {

			/*
			 *  륪ƥåȿ (len) 
			 *  κȥ (maxseg) 
			 *  פȤ롣
			 */
			if (len == cep->maxseg) {
				error = send_segment(&sendalot, cep, doff, win, (UINT)len, flags);
				continue;
				}

			/*
			 *  ǡХåեˤǤ
			 *  ɥ뤫 PUSH ץͭʤȤ
			 */
			if ((idle || (cep->flags & TCP_CEP_FLG_NO_DELAY)) &&
			    (cep->flags & TCP_CEP_FLG_NO_PUSH) == 0 &&
			    len + doff >= cep->swbuf_count) {
				error = send_segment(&sendalot, cep, doff, win, (UINT)len, flags);
				continue;
				}

			/*
			 *  max_sndwnd: ޤǤκɥ
			 *  snd_nxt:     SEQ
			 *  snd_max:     SEQ
			 *
			 *  ξǤԤ
			 *
			 *    ե饰åȤƤ롣
			 *    ǡĹκμɥ 1/2 ʾǡ
			 *      κμɥ 0 礭
			 *     SEQ  SEQ 꾮
			 *      ĤޤꡢȤ
			 */
			if ((cep->flags & TCP_CEP_FLG_FORCE) ||
			    (len >= cep->max_sndwnd / 2 && cep->max_sndwnd > 0) ||
			    SEQ_LT(cep->snd_nxt, cep->snd_max)) {
				error = send_segment(&sendalot, cep, doff, win, (UINT)len, flags);
				continue;
				}
			}


		/*
		 *  򤫤ʥɥɥβ (¦)
		 *
		 *  ɥե륵 2 ܤΥȡ뤤
		 *  Хåե̤ 1/2 Ρ줫ۤ
		 *  äϡɥιԤ
		 */
		if (win > 0) {
			long adv;

			/*
			 *  win:              Хåեζ
			 *  MAX_TCP_WIN_SIZE: TCP إå win եɤǤ
			 *  rcv_adv:          ԤƤ SEQ
			 *  rcv_nxt:          ԤƤǾ SEQ
			 */
			if (win < MAX_TCP_WIN_SIZE)
				adv = win - (cep->rcv_adv - cep->rcv_nxt);
			else
				adv = MAX_TCP_WIN_SIZE - (cep->rcv_adv - cep->rcv_nxt);

			if (adv     >= (long)(cep->maxseg * 2) ||
			    adv * 2 >= (long) cep->rbufsz) {
				error = send_segment(&sendalot, cep, doff, win, (UINT)len, flags);
				continue;
				}
			}
	
		/*
		 *  ACK 롣
		 */
		if (cep->flags & TCP_CEP_FLG_ACK_NOW) {
			error = send_segment(&sendalot, cep, doff, win, (UINT)len, flags);
			continue;
			}

		if ( (flags & TCP_FLG_RST) ||
		    ((flags & TCP_FLG_SYN) && (cep->flags & TCP_CEP_FLG_NEED_SYN) == 0)) {
			error = send_segment(&sendalot, cep, doff, win, (UINT)len, flags);
			continue;
			}

#ifdef TCP_CFG_EXTENTIONS

		if (SEQ_GT(cep->snd_up, cep->snd_una)) {
			error = send_segment(&sendalot, cep, doff, win, (UINT)len, flags);
			continue;
			}

#endif	/* of #ifdef TCP_CFG_EXTENTIONS */

		/*
		 *  snd_nxt:  SEQ
		 *  snd_una: ̤ǧκǾ SEQޤϳǧ줿 SEQ
		 *
		 *  ꤫ FIN ޤ FIN Ƥʤ
		 *  ǡʤȤϡFIN Ϥ뤿ᡢ
		 *  Ȥ롣
		 */
		if ((flags & TCP_FLG_FIN) &&
		    ((cep->flags & TCP_CEP_FLG_SENT_FIN) == 0 || cep->snd_nxt == cep->snd_una)) {
			error = send_segment(&sendalot, cep, doff, win, (UINT)len, flags);
			continue;
			}

		/*
		 *  ٤ǡꡢޤȻ³ޤڤƤȤ
		 *  ³ޤꤹ롣
		 */
		if (cep->swbuf_count && cep->timer[TCP_TIM_REXMT  ] == 0 &&
		                        cep->timer[TCP_TIM_PERSIST] == 0) {
			cep->rxtshift = 0;
			tcp_set_persist_timer(cep);
			break;
			}
		
		}
	}

#ifdef TCP_CFG_SWBUF_CSAVE

/*
 *  tcptsk_alloc_swbufq -- ɥХåե
 */

static void
tcptsk_alloc_swbufq (T_TCP_CEP *cep)
{
 	ER	error;
	UINT	win;

	/*
	 *  snd_wnd:  μǽɥ
	 *  snd_cwnd: ԥɥ
	 *
	 *  win: ɤ餫ɥꤹ롣
	 */
	win = cep->snd_wnd < cep->snd_cwnd ? cep->snd_wnd : cep->snd_cwnd;

	/*
	 *  μɤĤƤϡޤԵ롣
	 */
	if (win == 0) {
		cep->flags = (cep->flags & ~TCP_CEP_FLG_WBCS_MASK) | TCP_CEP_FLG_WBCS_WOPEN_PEND;
		}
	else {

#ifdef TCP_CFG_NON_BLOCKING

		/* Υ֥å󥰥 */
		if (!IS_PTR_DEFINED(cep->callback)) {
			syslog(LOG_WARNING, "[TCP] no call back, CEP: %d.", GET_TCP_CEPID(cep));

			/* Ƥ륿 ID  API ǽɤ򥯥ꥢ롣*/
			cep->snd_tskid = TA_NULL;
			cep->snd_tfn   = cep->snd_nblk_tfn = TFN_TCP_UNDEF;
			return;
			}

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

		if ((error = tcp_get_segment(&cep->swbufq, cep, 0,
		                             (UINT) TCP_CFG_SWBUF_CSAVE_MIN_SIZE,
		                             (UINT)(TCP_CFG_SWBUF_CSAVE_MAX_SIZE - IF_IP_TCP_HDR_SIZE),
		                             (ATR)(NBA_SEARCH_DESCENT |
		                                   NBA_RESERVE_TCP    |
		                                   (GET_TCP_CEPID(cep) & NBA_ID_MASK)), TMO_POL)) != E_OK) {

			/* ͥåȥХåեͽ󤹤롣*/
			cep->flags = (cep->flags & ~TCP_CEP_FLG_WBCS_MASK) | TCP_CEP_FLG_WBCS_NBUF_PEND;
			}
		else {

			/* ɥХåե롣*/
			tcp_init_swbuf(cep);

#ifdef TCP_CFG_NON_BLOCKING

			if (cep->snd_nblk_tfn == TFN_TCP_GET_BUF) {
				UINT len;

				/* ɥХåեν񤭹ߥɥ쥹ꤹ롣*/
				len = TCP_GET_SWBUF_ADDR(cep, cep->snd_p_buf);

				/* ХåؿƤӽФ*/
				(*cep->callback)(GET_TCP_CEPID(cep), cep->snd_nblk_tfn, (VP)(UW)len);

				/* Ƥ륿 ID  API ǽɤ򥯥ꥢ롣*/
				cep->snd_tskid = TA_NULL;
				cep->snd_tfn   = cep->snd_nblk_tfn = TFN_TCP_UNDEF;
				}

			else {	/* cep->snd_nblk_tfn == TFN_TCP_SND_DAT || */
				/* cep->snd_nblk_tfn == TFN_TCP_SND_OOB    */

				UINT len;

				/* ɥХåե˥ǡ񤭹ࡣ*/
				len = TCP_WRITE_SWBUF(cep, cep->snd_data, (UINT)cep->snd_len);

#ifdef TCP_CFG_EXTENTIONS

				/* ۵ޥݥ󥿤ꤹ롣*/
			        if (cep->snd_nblk_tfn == TFN_TCP_SND_OOB)
					cep->snd_up = cep->snd_una + len;

#endif	/* of #ifdef TCP_CFG_EXTENTIONS */

				/* ե饰ǽꤷŪ롣*/
				cep->flags |= TCP_CEP_FLG_FORCE | TCP_CEP_FLG_FORCE_CLEAR | TCP_CEP_FLG_POST_OUTPUT;

				/* ХåؿƤӽФ*/
				(*cep->callback)(GET_TCP_CEPID(cep), cep->snd_nblk_tfn, (VP)(UW)len);

				/* Ƥ륿 ID  API ǽɤ򥯥ꥢ롣*/
				cep->snd_tskid = TA_NULL;
				cep->snd_tfn   = cep->snd_nblk_tfn = TFN_TCP_UNDEF;
				}

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

			}
		}
	}

/*
 *  tcptsk_free_swbufq -- ɥХåե
 */

static void
tcptsk_free_swbufq (T_TCP_CEP *cep)
{
	/*
	 *  ǧλͥåȥ󥿥ե
	 *  ϤⴰλȤϡɥХåե塼롣
	 */

	/* ɥХåեλ極ꥻåȤ롣*/
	cep->swbuf_count = 0;

	/* ɥХåե塼ΥͥåȥХåե롣*/
	syscall(rel_net_buf(cep->swbufq));
	cep->swbufq = NULL;

	/* ե饰ꤹ롣*/
	cep->flags = (cep->flags & ~TCP_CEP_FLG_WBCS_MASK) | TCP_CEP_FLG_WBCS_FREE;

	/* ɥХåե˶ǤȤΤ餻롣*/
	syscall(set_flg(cep->snd_flgid, CEP_EVT_SWBUF_READY));

	/* ɥХåեζԤΤȤϡTCP ϥư롣*/
	if ((cep->flags & TCP_CEP_FLG_WBCS_NBUF_REQ) != 0) {
		sig_sem(SEM_TCP_POST_OUTPUT);
		}
	}

#endif	/* of #ifdef TCP_CFG_SWBUF_CSAVE */

/*
 *  TCP ϥ
 */

void
tcp_output_task (VP_INT exinf)
{
	static int last_ix = 0;

	T_TCP_CEP	*cep;
	ID		tskid;
 	int		ix, sel_ix;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP OUTPUT:%d] started.", tskid);

	tcp_init();

#ifdef SUPPORT_INET6

	/* IPv6 Υơȥ쥹ɥ쥹ư¹Ԥ롣*/
	in6_if_up(IF_GET_IFNET());

#endif	/* of #ifdef SUPPORT_INET6 */

	while (TRUE) {

		/* ϤݥȤޤԤġ*/
		syscall(wai_sem(SEM_TCP_POST_OUTPUT));

		if (++ last_ix == tmax_tcp_cepid)
			last_ix = 0;
		sel_ix = ix = last_ix;
		do {
			cep = &tcp_cep[ix];

#ifdef TCP_CFG_SWBUF_CSAVE

			if ((cep->flags & TCP_CEP_FLG_WBCS_NBUF_REQ) != 0 &&
			    ((cep->flags & TCP_CEP_FLG_WBCS_MASK) == TCP_CEP_FLG_WBCS_FREE ||
			     (cep->flags & TCP_CEP_FLG_WBCS_MASK) == TCP_CEP_FLG_WBCS_NBUF_RSVD)) {
				tcptsk_alloc_swbufq(cep);
				sel_ix = ix;
				}

			if ((cep->flags & TCP_CEP_FLG_WBCS_MASK) == TCP_CEP_FLG_WBCS_ACKED &&
			    (cep->swbufq->flags & NB_FLG_NOREL_IFOUT) == 0) {
				tcptsk_free_swbufq(cep);
				sel_ix = ix;
				}

			/*
			 *  ͥåȥ󥿥եäƤʤȤϡ
			 *  ͽ󤹤롣
			 */
			if (cep->flags & TCP_CEP_FLG_POST_OUTPUT &&
			   (cep->flags & TCP_CEP_FLG_WBCS_MASK) >= TCP_CEP_FLG_WBCS_SENT) {
				syscall(wai_sem(cep->semid_lock));
				if (cep->swbufq == NULL)
					cep->flags &= ~TCP_CEP_FLG_POST_OUTPUT;
				else if (cep->swbufq->flags & NB_FLG_NOREL_IFOUT) {
					cep->flags &= ~TCP_CEP_FLG_POST_OUTPUT;
					cep->flags |=  TCP_CEP_FLG_RESERVE_OUTPUT;
					}
				syscall(sig_sem(cep->semid_lock));
				}

			/*
			 *  ͽˡͥåȥ󥿥եλ顢
			 *  򳫻Ϥ롣λȤϲ⤷ʤ
			 */
			if (cep->flags & TCP_CEP_FLG_RESERVE_OUTPUT) {
				syscall(wai_sem(cep->semid_lock));
				if (cep->swbufq != NULL && (cep->swbufq->flags & NB_FLG_NOREL_IFOUT) == 0) {
					cep->flags |=  TCP_CEP_FLG_POST_OUTPUT;
					}
				syscall(sig_sem(cep->semid_lock));
				cep->flags &= ~TCP_CEP_FLG_RESERVE_OUTPUT;
				}

#endif	/* of #ifdef TCP_CFG_SWBUF_CSAVE */

			if (cep->flags & TCP_CEP_FLG_POST_OUTPUT) {

				cep->flags &= ~TCP_CEP_FLG_POST_OUTPUT;

#ifdef TCP_CFG_NON_BLOCKING

				if (cep->snd_nblk_tfn == TFN_TCP_CON_CEP && cep->myaddr.portno == TCP_PORTANY) {
				 	ER	error;

					/*
					 *  tcp_con_cep ΥΥ֥å󥰥ǡ
					 *  ̤ΤξϡݡֹƤ롣
					 *  p_myaddr  NADR (-1) 
					 *  ݡֹ椬 TCP_PORTANY ʤ顢ưǳƤ롣
					 */
					if (cep->p_myaddr == NADR || cep->p_myaddr->portno == TCP_PORTANY)
						tcp_alloc_auto_port(cep);
					else if ((error = tcp_alloc_port(cep, cep->p_myaddr->portno)) != E_OK) {

						if (IS_PTR_DEFINED(cep->callback))
							(*cep->callback)(GET_TCP_CEPID(cep), cep->snd_nblk_tfn, (VP)error);
						else
							syslog(LOG_WARNING, "[TCP] no call back, CEP: %d.", GET_TCP_CEPID(cep));

						/* Ƥ륿 ID  API ǽɤ򥯥ꥢ롣*/
						cep->snd_tfn   = cep->snd_nblk_tfn = TFN_TCP_UNDEF;
						cep->snd_tskid = TA_NULL;
						continue;
						}
					}

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

				tcp_output(cep);

				if (cep->flags & TCP_CEP_FLG_CLOSE_AFTER_OUTPUT) {
					/* ͥĤ롣*/
					tcp_close(cep);
					cep->flags &= ~TCP_CEP_FLG_CLOSE_AFTER_OUTPUT;
					}

				if (cep->flags & TCP_CEP_FLG_RESTORE_NEXT_OUTPUT) {
					/* snd_nxt 򸵤᤹*/
					if (SEQ_GT(cep->snd_old_nxt, cep->snd_nxt))
						cep->snd_nxt = cep->snd_old_nxt;
					cep->flags &= ~TCP_CEP_FLG_RESTORE_NEXT_OUTPUT;
					}

				sel_ix = ix;
				}

			if (++ ix == tmax_tcp_cepid)
				ix = 0;
			} while (ix != last_ix);

		/* ϡ̿ü󤷤ˤ롣*/
		last_ix = sel_ix;
		}
	}

#endif	/* of #ifdef SUPPORT_TCP */
